#include<vector>
#ifndef __VECTOR_PERM_H_
#define __VECTOR_PERM_H_
//recursive template permutation function
//Note : func parameters must always be vector<T> !
template <typename T, typename Func>
void vector_permutation(std::vector<T>& now,
          std::vector<T> next, Func func)
{
  int size=now.size();
  if(size>0)
  {
    for(int cnt=0; cnt<size;++cnt)
    {
      std::vector<T> vt;
      typename std::vector<T>::const_iterator it=now.begin();
      for(int cnt1=0;cnt1<size;++cnt1)
      {
        if(cnt1==cnt)
        {
          ++it;
          continue;
        }
        else
          vt.push_back(*it);
        ++it;  
      }
      typename std::vector<T>::const_iterator it1=now.begin();
      --it1;
      for(int cnt2=0;cnt2<=cnt;++cnt2)
        ++it1;
      next.push_back(*it1);
      vector_permutation(vt,next,func);
      next.pop_back();        
    }
  }          
  else
    func(next);
}
#endif
